#include <iostream>

#include "node.h"
#include "transition.h"


Node::Node(const std::string &n, TA *p)
    : name(n),
      parent(p)
{
}


Node::~Node()
{
    for (size_t i = 0; i < tr.size(); i++) {
	delete tr[i];
    }
}


void Node::addTrans(Transition *trans)
{
    tr.push_back(trans);
}


Node *Node::nextNode()
{
    Node *n = NULL;

    for (size_t i = 0; n == NULL && i < tr.size(); i++) {
	n = tr[i]->trigger();
    }
    if (!inv()) {
	error();
    }

    return (n == NULL) ? this : n;
}


void Node::error()
{
    std::cerr << "Error in node " << name << "!" << std::endl;
}
